const React = require('react')

const { dispatcher } = require('../lib/dispatcher')

class Header extends React.Component {
  render () {
    const loc = this.props.state.location
    return (
      React.createElement( 'div', {
        className: 'header', onMouseMove: dispatcher('mediaMouseMoved'), onMouseEnter: dispatcher('mediaControlsMouseEnter'), onMouseLeave: dispatcher('mediaControlsMouseLeave') },
        this.getTitle(),
        React.createElement( 'div', { className: 'nav left float-left' },
          React.createElement( 'i', {
            className: 'icon back ' + (loc.hasBack() ? '' : 'disabled'), title: 'Back', onClick: dispatcher('back') }, "chevron_left"),
          React.createElement( 'i', {
            className: 'icon forward ' + (loc.hasForward() ? '' : 'disabled'), title: 'Forward', onClick: dispatcher('forward') }, "chevron_right")
        ),
        React.createElement( 'div', { className: 'nav right float-right' },
          this.getAddButton()
        )
      )
    )
  }

  getTitle () {
    if (process.platform !== 'darwin') { return null }
    const state = this.props.state
    return (React.createElement( 'div', { className: 'title ellipsis' }, state.window.title))
  }

  getAddButton () {
    const state = this.props.state
    if (state.location.url() !== 'home') { return null }
    return (
      React.createElement( 'i', {
        className: 'icon add', title: 'Add torrent', onClick: dispatcher('openFiles') }, "add")
    )
  }
}

module.exports = Header
