const React = require('react')
const electron = require('electron')

const ModalOKCancel = require('./modal-ok-cancel')
const { dispatcher } = require('../lib/dispatcher')

module.exports = class UnsupportedMediaModal extends React.Component {
  render () {
    const state = this.props.state
    const err = state.modal.error
    const message = (err && err.getMessage)
      ? err.getMessage()
      : err
    const onAction = state.modal.externalPlayerInstalled
      ? dispatcher('openExternalPlayer')
      : () => this.onInstall()
    const actionText = state.modal.externalPlayerInstalled
      ? 'PLAY IN ' + state.getExternalPlayerName().toUpperCase()
      : 'INSTALL VLC'
    const errorMessage = state.modal.externalPlayerNotFound
      ? 'Couldn\'t run external player. Please make sure it\'s installed.'
      : ''
    return (
      React.createElement( 'div', null,
        React.createElement( 'p', null, React.createElement( 'strong', null, "Sorry, we can't play that file." ) ),
        React.createElement( 'p', null, message ),
        React.createElement( ModalOKCancel, {
          cancelText: 'CANCEL', onCancel: dispatcher('backToList'), okText: actionText, onOK: onAction }),
        React.createElement( 'p', { className: 'error-text' }, errorMessage)
      )
    )
  }

  onInstall () {
    electron.shell.openExternal('http://www.videolan.org/vlc/')

    // TODO: dcposch send a dispatch rather than modifying state directly
    const state = this.props.state
    state.modal.externalPlayerInstalled = true // Assume they'll install it successfully
  }
}
