const React = require('react')
const electron = require('electron')

const ModalOKCancel = require('./modal-ok-cancel')
const { dispatch } = require('../lib/dispatcher')

module.exports = class UpdateAvailableModal extends React.Component {
  render () {
    const state = this.props.state
    return (
      React.createElement( 'div', { className: 'update-available-modal' },
        React.createElement( 'p', null, React.createElement( 'strong', null, "A new version of WebTorrent is available: v", state.modal.version ) ),
        React.createElement( 'p', null, "We have an auto-updater for Windows and Mac. We don't have one for Linux yet, so you'll have to download the new version manually." ),
        React.createElement( ModalOKCancel, {
          cancelText: 'SKIP THIS RELEASE', onCancel: handleSkip, okText: 'SHOW DOWNLOAD PAGE', onOK: handleShow })
      )
    )

    function handleShow () {
      // TODO: use the GitHub urls from config.js
      electron.shell.openExternal('https://github.com/webtorrent/webtorrent-desktop/releases')
      dispatch('exitModal')
    }

    function handleSkip () {
      dispatch('skipVersion', state.modal.version)
      dispatch('exitModal')
    }
  }
}
